/* TODO - Define the tests to ensure your functions are working properly. All
          tests should not be implemented in runAllTests, instead, use multiple
          functions each dedicated to performing a specific series of tests
   TODO - Make sure you also document the justification for each single tests.
*/


#include <stdio.h>
#include <stdlib.h> 
#include <string.h>
#include "tools.h"


/* Uncomment the following for extra information while tests are being run */
#define VERBOSE_TESTING




/* Tests for taurahize_word ----------------------------------------------------
*/ 

#define NBPHRASES 3
#define PHRASES               { {"a aa aaa ", "A Ba Aki"},\
                                {"aaa    aaa", "Aki Aki"},\
                                {"aaaa aaa", "Aoke Aki"}\
                                };
/* TODO - Justifications for Tests 
   #1   is used to ... 
   #2   ... 
   #3   ... 
*/                                



/* Tests for taurahize_phrase --------------------------------------------------
*/
#define NBSINGLEWORDS 3
#define SINGLEWORDS           { {"a", "A"},\
                                {"aa", "Ba"},\
                                {"aaaa", "Aoke"}\
                                };
/* TODO - Justifications for Tests 
   #1   is used to ... 
   #2   ... 
   #3   ... 
*/                                



void runSingleWordTests(){ 
     /* ROLE       Runs tests on the taurahize_word function  
     */   
     int n = 0; 
     char *translation = NULL; 
     const char *words[NBSINGLEWORDS][2] = SINGLEWORDS; 
     
     printf("TESTING SINGLE WORDS\n"); 
     
     for(n=0 ; n < NBSINGLEWORDS ; n++){
              translation = taurahize_word(words[n][0]); 
              if(strcmp(translation, words[n][1]) == 0)
			      printf("Test #%d\t%s\n", n, "OK"); 
              else
			      printf("Test #%d\t%s\n", n, "FAILED"); 
            
              #ifdef VERBOSE_TESTING 
              printf("\tinput is \t%s\n", words[n][0]); 
              printf("\texpected is \t%s\n", words[n][0]);
              printf("\tobserved is \t%s\n", translation); 
              #endif
              free(translation);
     }
}

void runMultipleWordsTests(){
     /* ROLE       Runs tests on the taurahize_phrase function
     */
     int n = 0; 
     char *translation = NULL; 
     const char *phrases[NBPHRASES][2] = PHRASES; 
     
     printf("\n\n\nTESTING PHRASES TRANSLATIONS\n"); 
     
     for(n=0 ; n < NBPHRASES ; n++){
              translation = taurahize_phrase(phrases[n][0]); 
              if(strcmp(translation, phrases[n][1]) == 0)
			      printf("Test #%d\t%s\n", n, "OK"); 
              else
			      printf("Test #%d\t%s\n", n, "FAILED"); 
              
              #ifdef VERBOSE_TESTING 
              printf("\tinput is \t%s\n", phrases[n][0]); 
              printf("\texpected is \t%s\n", phrases[n][1]);
              printf("\tobserved is \t%s\n", translation); 
              #endif
              free(translation);
     }
}


void runAllTests(){
     /* ROLE       Runs all the tests specified and displays results
     */
    runSingleWordTests(); 
    runMultipleWordsTests(); 
}


